wxWidgets: wxStringTokenizer Class Reference

| Version: 3.1.5

Public Member Functions | List of all members
wxStringTokenizer Class Reference
Class List by Category » Data Structures

`#include </home/Hamis/wxwidgets-3.1/wxWidgets3.1-3.1.5-1.i686/src/wxWidgets-3.1.5/interface/wx/tokenzr.h>`

Inheritance diagram for wxStringTokenizer:
[legend]

## Detailed Description

wxStringTokenizer helps you to break a string up into a number of tokens.

It replaces the standard C function `strtok()` and also extends it in a number of ways.

To use this class, you should create a wxStringTokenizer object, give it the string to tokenize and also the delimiters which separate tokens in the string (by default, white space characters will be used).

Then wxStringTokenizer::GetNextToken() may be called repeatedly until wxStringTokenizer::HasMoreTokens() returns false.

For example:

wxStringTokenizer tokenizer("first:second:third:fourth", ":");
while ( tokenizer.HasMoreTokens() )
{
wxString token = tokenizer.GetNextToken();
// process token here
}
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:315
wxStringTokenizer
wxStringTokenizer helps you to break a string up into a number of tokens.
Definition: tokenzr.h:96

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxStringTokenize()

## Public Member Functions
| wxStringTokenizer ()
| Default constructor. More...
| wxStringTokenizer (const wxString &str, const wxString &delims=wxDEFAULT_DELIMITERS, wxStringTokenizerMode mode=wxTOKEN_DEFAULT)
| Constructor. More...
size_t | CountTokens () const
| Returns the number of tokens remaining in the input string. More...
wxChar | GetLastDelimiter () const
| Returns the delimiter which ended scan for the last token returned by GetNextToken() or `NUL` if there had been no calls to this function yet or if it returned the trailing empty token in wxTOKEN_RET_EMPTY_ALL mode. More...
wxString | GetNextToken ()
| Returns the next token or empty string if the end of string was reached. More...
size_t | GetPosition () const
| Returns the current position (i.e. one index after the last returned token or 0 if GetNextToken() has never been called) in the original string. More...
wxString | GetString () const
| Returns the part of the initial string which is yet to be tokenized. More...
bool | HasMoreTokens () const
| Returns true if the tokenizer has further tokens, false if none are left. More...
void | SetString (const wxString &str, const wxString &delims=wxDEFAULT_DELIMITERS, wxStringTokenizerMode mode=wxTOKEN_DEFAULT)
| Initializes the tokenizer. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxStringTokenizer() [1/2]

wxStringTokenizer::wxStringTokenizer | ( |  | ) |

Default constructor.

You must call SetString() before calling any other methods.

## ◆ wxStringTokenizer() [2/2]

wxStringTokenizer::wxStringTokenizer | ( | const wxString & | str,
|  | const wxString & | delims = `wxDEFAULT_DELIMITERS`,
|  | wxStringTokenizerMode | mode = `wxTOKEN_DEFAULT`
| ) |  |

Constructor.

Pass the string to tokenize, a string containing delimiters, and the mode specifying how the string should be tokenized.

See also
  SetString()

## Member Function Documentation

## ◆ CountTokens()

size_t wxStringTokenizer::CountTokens | ( |  | ) | const

Returns the number of tokens remaining in the input string.

The number of tokens returned by this function is decremented each time GetNextToken() is called and when it reaches 0, HasMoreTokens() returns false.

## ◆ GetLastDelimiter()

wxChar wxStringTokenizer::GetLastDelimiter | ( |  | ) | const

Returns the delimiter which ended scan for the last token returned by GetNextToken() or `NUL` if there had been no calls to this function yet or if it returned the trailing empty token in wxTOKEN_RET_EMPTY_ALL mode.

Since
  2.7.0

## ◆ GetNextToken()

wxString wxStringTokenizer::GetNextToken | ( |  | ) |

Returns the next token or empty string if the end of string was reached.

## ◆ GetPosition()

size_t wxStringTokenizer::GetPosition | ( |  | ) | const

Returns the current position (i.e. one index after the last returned token or 0 if GetNextToken() has never been called) in the original string.

## ◆ GetString()

wxString wxStringTokenizer::GetString | ( |  | ) | const

Returns the part of the initial string which is yet to be tokenized.

That is, the substring from the current position up to the end, possibly empty if there are no more tokens left.

## ◆ HasMoreTokens()

bool wxStringTokenizer::HasMoreTokens | ( |  | ) | const

Returns true if the tokenizer has further tokens, false if none are left.

## ◆ SetString()

void wxStringTokenizer::SetString | ( | const wxString & | str,
|  | const wxString & | delims = `wxDEFAULT_DELIMITERS`,
|  | wxStringTokenizerMode | mode = `wxTOKEN_DEFAULT`
| ) |  |

Initializes the tokenizer.

Pass the string to tokenize, a string containing delimiters, and the mode specifying how the string should be tokenized.